/*! \file XMLParsingMQL4.mqh
    \headerfile XMLParsingMQL4.mqh
    \brief     .
    \author <a href="http://www.mql4.com/ru/users/BenMond">BenMond</a>
    
     //,      .
\code
#include <XmlParsingMQL4.mqh> //  -     
\endcode    
*/

/*! \mainpage 

: <a href="http://www.mql4.com/ru/users/BenMond">BenMond</a>

XML   ,          . 
         MQL4. 
     . 
 MQL5    <a href="http://www.mql5.com/ru/code/97"></a>. 
     DLL.       DLL. 
    ,  , ,     open source .

   ,            
 : myfxresearch@gmail.com

   ,   \subpage  "". 

     : 

- \ref SAX
- \ref DOM

     ,     System.Xml .NET.

    & amp;  &, & lt;  <, & gt;  >, & apos;  ', & quot;  "  .

     :

- XSD 
-     XPath
- XSL 

*/

/*! \page   
<h2>:</h2>
- <b>XMLParsingMQL4.mqh</b> -  .    <b>experts/include</b>  .
- <b>XMLParsingMQL4.mq4</b> -   .    <b>experts/libraries</b>  .
- <b>XML_SAX_Write.mq4</b> -   SAX ().    <b>experts/scripts</b>  .
- <b>XML_SAX_Read.mq4</b> -   SAX ().    <b>experts/scripts</b>  .
- <b>XML_DOM.mq4</b> -  DOM.    <b>experts/scripts</b>  .
- <b>XMLParsingMQL4.chm</b> -  

     //,      .
\code
#include <XmlParsingMQL4.mqh> //  -     
\endcode
*/

/*! \page SAX Simple API for XML (SAX)
    ,      XML . 
SAX-           
(..        ),      , 
        .

- \ref SAX_Write "/ Xml "
- \ref SAX_Read " Xml "

  SAX ().

\include XML_SAX_Write.mq4

  SAX ().

\include XML_SAX_Read.mq4
*/

/*! \page DOM Document Object Model (DOM)
          , 
     XML-.

- \ref GroupDOM "DOM     XML "

  DOM.

\include XML_DOM.mq4
*/

/*! \page About  
    <a href="http://www.opensource.org/licenses/apache2.0">Apache License, Version 2.0 </a>

: <a href="http://www.mql4.com/ru/users/BenMond">BenMond</a>

: <a href="http://www.MyFXResearch.com">www.MyFXResearch.com</a>

email: <a href="mailto:MyFXResearch@gmail.com">MyFXResearch@gmail.com</a>
*/


#property copyright "Copyright  2011, Ben"
#property link      "http://www.MyFXResearch.com"

#include <stdlib.mqh>            //    

#import "XmlParsingMQL4.ex4"     //   Xml 

/** @defgroup SAX_Write SAX. / Xml .
 *  @{
 */
 
///   FileName  .     - ,   -  .       -1   .
int XmlTextWriter(int& XmlTextWriter[],   ///< [in,out] XmlTextWriter Object
                  string FileName         ///< [in]    
                  );

///    Xml  <?Xml version="1.0" encoding="windows-1251" ?> . 
void WriteStartDocument(int& XmlTextWriter[], ///< [in,out] XmlTextWriter Object
                        string encoding       ///< [in] .  "windows-1251"
                        );

///      Name. <Name>
void WriteStartElement(int& XmlTextWriter[], ///< [in,out] XmlTextWriter Object
                        string Name          ///< [in]  . 
                        );

///   attrName   value. <Name attrName="value">
void WriteAttributeString(int& XmlTextWriter[], ///< [in,out] XmlTextWriter Object
                           string attrName,     ///< [in]  . 
                           string value         ///< [in]  .
                           );

///     text. <Name>text</Name>
void WriteString(int& XmlTextWriter[],    ///< [in,out] XmlTextWriter Object
                  string text             ///< [in]  . 
                  );

///     Name   value. <Name>value</Name>
void WriteElementString(int& XmlTextWriter[], ///< [in,out] XmlTextWriter Object
                        string Name,          ///< [in]  . 
                        string value          ///< [in]  .
                        );                    

///   <!-- text --> 
void WriteComment(int& XmlTextWriter[],   ///< [in,out] XmlTextWriter Object
                  string text             ///< [in]  .
                  );

///     Name. </Name>
void WriteEndElement(int& XmlTextWriter[],   ///< [in,out] XmlTextWriter Object
                     string Name             ///< [in]  . 
                     );

///  . 
void WriteEndDocument(int& XmlTextWriter[]   ///< [in,out] XmlTextWriter Object
                     );

/** @} */ // end of SAX_Write

/** @defgroup SAX_Read SAX.  Xml .
 *  @{
 */

///   FileName  .   XmlTextReader.  true   ,  false.
bool XmlTextReader(int& XmlTextReader[], ///< [in,out] XmlTextReader Object
                     string FileName     ///< [in]  
                     );

///         .       .
string XmlRead(int& XmlTextReader[]       ///< [in,out] XmlTextReader Object
               );

///  XmlTextReader.
void XmlClose(int& XmlTextReader[]  ///< [in,out] XmlTextReader Object
               );

/** @} */ // end of SAX_Read

/** @defgroup GroupDOM DOM.    Xml 
 *  @{
 */

///  Xml  FileName.  .
string XmlDocument(string FileName  ///< [in]  
                   );

///    Node   aChildNodes.
void XmlDocChildNodes(string Node,              ///< [in] Xml 
                      string &aChildNodes[]     ///< [out]    
                      );

///    Child
string XmlDocAppendChild(string Node,  /// [in] Xml 
                         string Child  /// [in]  
                         );

///      Name   aNodes.
void XmlDocGetElementsByTagName(string doc,           /// [in] Xml 
                                string &aNodes[],     /// [out]   
                                string Name           /// [in]  
                                );

///  doc 
string XmlDocFormat(string doc   /// [in] Xml 
                     );

///  doc  OutPutFileName
void XmlDocSave(string doc,            /// [in] Xml 
                string OutPutFileName, ///  
                string encoding        ///  "windows-1251"
                );

///     Name   <Name></Name>
string XmlDocCreateElement(string Name /// [in]  
                           );

///     <Name>Text</Name>
string XmlDocText(string Node                   ///< [in] 
                  );

///    text  <Name>text</Name>
string XmlDocSetElementText(string Node, /// [in] 
                            string text  /// [in] 
                            );

///   AttrName   value
string XmlDocAppendAttribute(string Node,       /// [in] 
                             string AttrName,   /// [in]  
                             string value       /// [in]  
                             );

/** @} */ // end of GroupDOM

/** @defgroup TYPE     
 *  @{
 */

///      <item>
bool XmlDocIsElement(string Tag  /// [in] 
                     );

///      </item>
bool XmlDocIsEndElement(string Tag  /// [in] 
                        );

///      
bool XmlDocIsText(string Tag  /// [in] 
                  );

///     <!-- My Comment -->
bool XmlDocIsComment(string Tag  /// [in] 
                     );

///   Tag . <item />
bool XmlDocIsClosedTag(string Tag   /// [in] 
                       );

/** @} */ // end of TYPE

/** @defgroup COMMON     
 *  @{
 */

///    . <Name>
string XmlDocName(string Node       ///< [in] 
                  );

///   AttrName.
string XmlDocAttribute(string Node,       ///< [in] 
                       string AttrName    ///< [in]  
                       );

/** @} */ // end of COMMON


