/*! \file XML_DOM.mq4
    \brief   DOM.
    \example XML_DOM.mq4
    \author <a href="http://www.mql4.com/ru/users/BenMond">BenMond</a>
    
   Document Object Model (DOM).
             , 
        XML-.
*/

#property copyright "Copyright  2011, Ben"
#property link      "http://www.MyFXResearch.com"

#include <XmlParsingMQL4.mqh> //  -     

int start()  {
   string FileName = "test.Xml";
   string doc = XmlDocument(FileName);
   string aChildNodes[];
   int i;
   
   if(XmlDocName(doc)=="") {
      Print(" : "+XmlDocAttribute(doc, ""));
      string SymbolList = "  :";
      XmlDocChildNodes(doc,aChildNodes);
      for(i=0;i<ArraySize(aChildNodes);i++) {
         if(XmlDocName(aChildNodes[i])=="") {
            SymbolList = SymbolList + " " + XmlDocAttribute(aChildNodes[i], "Name");
         }
      }
      Print(SymbolList);
   }
   
   string aNodes[];
   XmlDocGetElementsByTagName(doc, aNodes, "");
   for(i=0;i<ArraySize(aNodes);i++) {
      Print(": "+XmlDocText(aNodes[i]));
   }
   
   string OutPutFileName = "output.Xml";

   string Symb = XmlDocCreateElement("");
   Symb = XmlDocAppendAttribute(Symb, "Name", "EURNZD");

   doc = XmlDocAppendChild(doc, Symb);
   
   Symb = XmlDocCreateElement("");

   Symb = XmlDocSetElementText(Symb, "&SA currency");

   Symb = XmlDocAppendAttribute(Symb, "Name", "ZARUSD");
   
   doc = XmlDocAppendChild(doc, Symb);

   Symb = XmlDocAppendAttribute("< />", "Name", "RUB&USD");

   doc = XmlDocAppendChild(doc, Symb);

   Symb = XmlDocCreateElement("");
   Symb = XmlDocAppendAttribute(Symb, "Name", "EURCAD");

   string HighElement  = XmlDocAppendAttribute(XmlDocCreateElement("High" ), "value", DoubleToStr(iHigh ("EURCAD",0,1),Digits));
   string LowElement   = XmlDocAppendAttribute(XmlDocCreateElement("Low"  ), "value", DoubleToStr(iLow  ("EURCAD",0,1),Digits));

   Symb = XmlDocAppendChild(Symb, HighElement);
   Symb = XmlDocAppendChild(Symb, LowElement);
         
   doc = XmlDocAppendChild(doc, Symb);

   Symb = XmlDocCreateElement("");
   Symb = XmlDocAppendAttribute(Symb, "Name", "EURCHF");

   HighElement  = XmlDocAppendAttribute(XmlDocCreateElement("High" ), "value", DoubleToStr(iHigh ("EURCHF",0,1),Digits));
   LowElement   = XmlDocAppendAttribute(XmlDocCreateElement("Low"  ), "value", DoubleToStr(iLow  ("EURCHF",0,1),Digits));

   Symb = XmlDocAppendChild(Symb, HighElement);
   Symb = XmlDocAppendChild(Symb, LowElement);
         
   doc = XmlDocAppendChild(doc, Symb);

   XmlDocSave(doc, OutPutFileName, "windows-1251");
   Print(" "+TerminalPath()+StringTrimRight("\\experts\\files\\ ")+OutPutFileName+"  ");

   return(0);
}


